test-app/routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes(['verify' => true]);

Route::get('/home', 'HomeController@index')->name('home');
Route::get('register/{refferal}', 'Auth\RegisterController@showRefferalRegistrationForm')->name('register-refferal-form');

Route::middleware(['auth'])->group(function () {
    Route::get('/user/{user}/profile', 'UserProfileController@view')->name('profile');
    Route::post('/user/{user}/update-profile', 'UserProfileController@updateProfile')->name('update-profile');
    Route::post('/user/{user}/update-password', 'UserProfileController@updatePassword')->name('update-password');

    Route::resource('transaction', 'TransactionController')->except([
        'destroy'
    ]);
});

test-app/app/Http/Controllers/TransactionController.php
<?php

namespace App\Http\Controllers;

use App\Transaction;
use Illuminate\Http\Request;

class TransactionController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $allTransactions = Transaction::where('user_id', \Auth::id())->get();
        $totalBalance =  \Auth::user()->getBallance();

        return view('transaction.index', compact(['allTransactions', 'totalBalance']));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('transaction.create', compact('allTransactions'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([
            'ammount' => 'required|numeric|min:10'
        ]);
        
        Transaction::registerTransaction((float)$request->input('ammount'), Transaction::TRANS_STATUS_SUCCESS);
    
        $request->session()->flash('message', 'Transaction was processed with success!');
    
        return redirect()->route('transaction.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Transaction  $transaction
     * @return \Illuminate\Http\Response
     */
    public function show(Transaction $transaction)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Transaction  $transaction
     * @return \Illuminate\Http\Response
     */
    public function edit(Transaction $transaction)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Transaction  $transaction
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Transaction $transaction)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Transaction  $transaction
     * @return \Illuminate\Http\Response
     */
    public function destroy(Transaction $transaction)
    {
        //
    }
}

test-app/resources/views/transaction/create.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">{{ __('Refill your account balance') }}</div>

                <div class="card-body">
                    <form method="POST" action="{{ route('transaction.store') }}">
                        @csrf

                        <div class="form-group row">
                            <label for="ammount" class="col-md-4 col-form-label text-md-right">{{ __('Ammount') }}</label>

                            <div class="col-md-6">
                                <input id="ammount" type="number" class="form-control" name="ammount" value="{{ old('ammount') }}" min="10" required autofocus>

                                @if ($errors->has('ammount'))
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $errors->first('ammount') }}</strong>
                                    </span>
                                @endif
                            </div>
                        </div>

                        <div class="form-group row mb-0">
                            <div class="col-md-8 offset-md-4">
                                <button type="submit" class="btn btn-primary">
                                    {{ __('Refill') }}
                                </button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

test-app/resources/views/transaction/index.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">{{ __('All my transactions') }}</div>

                <div class="card-body">
                    @if(count($allTransactions) > 0 )
                        <table class="table table-striped">
                            <thead>
                                <tr>
                                    <th scope="col">#</th>
                                    <th scope="col">Ammount</th>
                                    <th scope="col">Status</th>
                                    <th scope="col">Type</th>
                                    <th scope="col">Date</th>
                                </tr>
                            </thead>
                            <tbody>
                            @foreach($allTransactions as $transaction)
                                <tr>
                                    <th scope="row">{{ $transaction->id }}</th>
                                    <td>{{ $transaction->ammount }}</td>
                                    <td>{{ $transaction->status }}</td>
                                    <td>{{ $transaction->type }}</td>
                                    <td>{{ $transaction->created_at }}</td>
                                </tr>
                            @endforeach
                                <tr>
                                    <th scope="row">{{ __('Total') }}</th>
                                    <td>{{ $totalBalance }}</td>
                                    <td></td>
                                    <td></td>
                                    <td></td>
                                </tr>
                            </tbody>
                        </table>
                    @else 
                        {{__('No transactions at the moment!') }}
                    @endif
                </div>
            </div>
        </div>
    </div>
</div>
@endsection